import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class Logout extends HttpServlet {
    
  public void doGet (HttpServletRequest request,
                     HttpServletResponse response)
      throws ServletException, IOException {

    doPost(request,response);
  }

  public void doPost (HttpServletRequest request,
                     HttpServletResponse response)
      throws ServletException, IOException {

	response.setContentType("text/html");
	PrintWriter out = response.getWriter();

    String cno[] = request.getParameterValues("customerId");	
    String uAccess[] = request.getParameterValues("uAccess");	

	try {
	  Class.forName("oracle.jdbc.driver.OracleDriver");
    } catch(ClassNotFoundException e){
	    out.println("Error loading the Driver:"+e.getMessage()); 
        return;
	  }
	
	Connection conn = null;
	
	try {
	  conn = DriverManager.getConnection (
         MyUtilities.CONNECTSTRING,MyUtilities.ID,MyUtilities.PASSWORD);
	} catch (SQLException e1) {
	    out.println("Error connecting to Oracle:"+e1.getMessage()); 
        return;
	  }
    if (conn == null) {
      out.println("Null Connection");
      return;
    }
	
	Statement stmt = null;
	try {
	  stmt = conn.createStatement ();
	} catch (SQLException e) {
	    out.println("createStatement " + e.getMessage());
        try {conn.close();} catch (SQLException e2) {};
        return;
	  }
	
	ResultSet rset = null;
	
    String query0 = "select u_access from customers where cno='"+ cno[0]+"'";
	try {
	    rset = stmt.executeQuery(query0);
	} catch (SQLException e) {
	    out.println("executeQuery " + e.getMessage());
        return;
      }
	try {
	  if (!(rset.next())) {
        out.println("Session has already expired!");
        return;
      }
      else if (!(uAccess[0].equals(rset.getString(1)))) {
          out.println("Session has already expired!");
          return;
        }
      else { // everything is fine
        String sTrack = "select 1440*(sysdate-l_access) from customers where cno='" + cno[0] + "'";
        rset = stmt.executeQuery(sTrack);
        rset.next();
        if (rset.getDouble(1) > 10.0) {
                      out.println("<html>");
            out.println("  <head>");
            out.println("    <title>Logout Page</title>");
            out.println("  </head>");
            out.println("  <body>");

            int nRows = stmt.executeUpdate("update customers set u_access = null where cno='" + cno[0] + "'");
            out.println("Your session has expired!<BR> Please Login again to continue shopping.");
            out.println("</center>");
            out.println("</body>");
            out.println("</html>");
            return;
         }
                               
         int nRows = stmt.executeUpdate("update customers set l_access = sysdate where cno='" + cno[0] + "'");

        String query1 = "select cartno from cart where cno='" + cno[0] + "'";
        rset = stmt.executeQuery(query1);
        if ( (rset.next()) ) {
          out.println("<html>");
          out.println("  <head>");
          out.println("    <title>Logout Page</title>");
          out.println("  </head>");
          out.println("  <body>"); 
          out.println("<center>");
          out.println("<B>Logout Page</B><BR><BR>");
          out.println("<BR><BR>Your Shopping Cart has items in it!");
          out.println("<BR>Please choose one of the following options before logging out.");
          out.println("<form method=\"POST\" action=\""+
             MyUtilities.URLPREFIX + "ProcessLogout\">"); 
          out.println("<input type = \"hidden\" name=\"customerId\" value=\"" + cno[0] + "\">");
          out.println("<input type = \"hidden\" name=\"uAccess\" value=\"" + uAccess[0] + "\">");
          out.println("<input type = \"hidden\" name=\"cartno\" value=\"" + rset.getString(1) + "\">");

          out.println("<table>");
          out.println("<tr>");
          out.println("<td>");
          out.println("<input type=\"radio\" checked name=\"choice\" value=\"CheckOut\">CheckOut");
          out.println("</td>");
          out.println("</tr>");
          out.println("<tr>");
          out.println("<td>");
          out.println("<input type=\"radio\" name=\"choice\" value=\"Save Cart and Logout\">Save Cart and Logout");
          out.println("</td>");
          out.println("</tr>");
          out.println("<tr>");
          out.println("<td>");
          out.println("<input type=\"radio\" name=\"choice\" value=\"Empty Cart and Logout\">Empty Cart and Logout");
          out.println("</td>");
          out.println("</tr>");
          out.println("</table>");
          out.println("<BR><BR>");
          out.println("<center><input type=\"submit\" value=\"Submit\"></center>");  
          out.println("</form>");
          out.println("</center>");
          out.println("</body>");
          out.println("</html>");
        }
        else { 
          out.println("<html>");
          out.println("  <head>");
          out.println("    <title>Logout Page</title>");
          out.println("  </head>");
          out.println("  <body>"); 
            
          nRows = stmt.executeUpdate("update customers set u_access = null where cno='" + cno[0] + "'");

          out.println("Logged Out!<BR> Thank You for Shopping with Web Shopping");
          out.println("</center>");
          out.println("</body>");
          out.println("</html>");
        }
      }
    } catch (SQLException e) {
         out.println("executeQuery " + e.getMessage());
         return;
      }

	
    try {
      stmt.close();
      conn.close();	
    } catch (SQLException e) {
        out.println("executeQuery " + e.getMessage());
        return;
      }
    
    out.close();
  }
    
    
  public String getServletInfo() {
    return "This Servlet processes Customer Login";
  }
}

