import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class pbook extends HttpServlet {

  HttpSession session;

  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
       throws IOException, ServletException {

    response.setContentType("text/html");

    session = request.getSession(true);
    session.invalidate();
    session = request.getSession(true);

    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("<body>");
    out.println("<head>");
    out.println("<title>A Session Phone Book</title>");
    out.println("</head>");
    out.println("<body>");
    out.println("<h2>Welcome to Phone Book</h2>");
    
    out.print("<form action=\"");
    out.print(response.encodeURL(
      "http://tinman.cs.gsu.edu:9999/raj/servlet/pbook"));
    out.print("\" ");
    out.println("method=\"POST\">");
    out.println("<P><P>Name:");
    out.println("<input type=\"text\" size=\"20\" name=\"name\">");
    out.println("<br>");
    out.println("Phone:");
    out.println("<input type=\"text\" size=\"20\" name=\"phone\">");
    out.println("<P><P>");
    out.println("<input type=\"submit\" value=\"Add Entry\">");
    out.println("</form>");
    out.println("</body>");
    out.println("</html>");
    out.close();
  }

  public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
       throws IOException, ServletException {

    Vector nms=null;
    Vector phs=null;
    int n=0;

    response.setContentType("text/html");

    String name = request.getParameter("name");
    String phone = request.getParameter("phone");
    String dels[] = request.getParameterValues("delIndex");

    session = request.getSession(true);
    if (session.getAttribute("numEntries") != null) { 
      Integer ne = (Integer) session.getAttribute("numEntries");
      n = ne.intValue();
      nms = (Vector) session.getAttribute("names");
      phs = (Vector) session.getAttribute("phoneNumbers");
    }
    else {
      nms = new Vector();
      phs = new Vector();
      n = 0; 
    }

    // Process Add Entry
    if ((!name.trim().equals("")) && (!phone.trim().equals(""))) {
      nms.addElement(name);
      phs.addElement(phone);
      n++;
      session.setAttribute("numEntries",new Integer(n)); 
      session.setAttribute("names",nms); 
      session.setAttribute("phoneNumbers",phs); 
    }

    // Process Delete Entries
    if (dels != null) {
      for (int i=(dels.length-1); i>=0; i--) {
        nms.remove(Integer.parseInt(dels[i]));
        phs.remove(Integer.parseInt(dels[i]));
        n--;
      }
      session.setAttribute("numEntries",new Integer(n)); 
      session.setAttribute("names",nms); 
      session.setAttribute("phoneNumbers",phs); 
    }

    // Display Page
    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("<body>");
    out.println("<head>");
    out.println("<title>A Session Phone Book</title>");
    out.println("</head>");
    out.println("<body>");
    out.println("<h2>Phone Book Entries</h2>");
    out.print("<form action=\"");
    out.print(response.encodeURL(
      "http://tinman.cs.gsu.edu:9999/raj/servlet/pbook"));
    out.print("\" ");
    out.println("method=\"POST\">");
    out.println("<table border=\"2\">");
    out.println("<tr>");
    out.print("<th>Name</th>");
    out.print("<th>Phone</th>");
    out.print("<th>Delete?</th>");
    out.println("</tr>");
    for (int i=0; i<n; i++) {
      out.println("<tr>");
      out.print("<td>"+nms.elementAt(i)+"</td>");
      out.print("<td>"+phs.elementAt(i)+"</td>");
      out.print("<td><input type=\"checkbox\" name=\"delIndex\" value=\""+
                     i+"\"/></td>");
      out.println("</tr>");
    } 
    out.println("</table>");
    out.println("<P><P>Add Entry:<P>");
    out.println("Name:");
    out.println("<input type=\"text\" size=\"20\" name=\"name\">");
    out.println("<br>");
    out.println("Phone:");
    out.println("<input type=\"text\" size=\"20\" name=\"phone\">");
    out.println("<P><P>");
    out.println("<input type=\"submit\" value=\"Update Phone Book\">");
    out.println("</form>");
    out.print("<P><P><form action=\"");
    out.print(response.encodeURL(
      "http://tinman.cs.gsu.edu:9999/raj/servlet/pbook"));
    out.print("\" ");
    out.println("method=\"GET\">");
    out.println("<input type=\"submit\" value=\"Start Over Again\">");
    out.println("</form>");

    out.println("</body>");
    out.println("</html>");
    out.close();
  }
}
