import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class Banner extends HttpServlet {
    
  public static Connection conn;
  public static Statement stmt;
    
  public void doGet (HttpServletRequest request,
                     HttpServletResponse response)
      throws ServletException, IOException {

    doPost(request,response);
  }

  public void doPost (HttpServletRequest request,
                     HttpServletResponse response)
      throws ServletException, IOException {

	response.setContentType("text/html");
	PrintWriter out = response.getWriter();

    String cno[] = request.getParameterValues("customerId");	

	try {
	  Class.forName("oracle.jdbc.driver.OracleDriver");
    } catch(ClassNotFoundException e){
	    out.println("Error loading the Driver:"+e.getMessage()); 
        return;
	  }
	
	Connection conn = null;
	
	try {
	  conn = DriverManager.getConnection(MyUtilities.CONNECTSTRING,
                     MyUtilities.ID,MyUtilities.PASSWORD);
	} catch (SQLException e1) {
	    out.println("Error connecting to Oracle:"+e1.getMessage()); 
        return;
	  }
    if (conn == null) {
      out.println("Null Connection");
      return;
    }
	
	Statement stmt = null;
	try {
	  stmt = conn.createStatement ();
	} catch (SQLException e) {
	    out.println("createStatement " + e.getMessage());
        try {conn.close();} catch (SQLException e2) {};
        return;
	  }
	
	ResultSet rset = null;
	
	String query = "select cname from customers where cno='"+cno[0]+"'";
	try {
	    rset = stmt.executeQuery(query);
	} catch (SQLException e) {
	    out.println("executeQuery " + e.getMessage());
        return;
      }

    String Name = "";
	try {
	  if (rset.next()) {
        Name = rset.getString(1);

out.println("<html>");
out.println("  <head>");
out.println("    <title>Customer Menu</title>");
out.println("  </head>");
out.println("  <body> ");
out.println("  <center> ");
out.println("<font size=5>Web Shopping Application System</font>");
out.println("  <BR>");
out.println("<font size=5><em>Welcome " + Name + "</em></font>");
out.println("  </center> ");
out.println("  </body> ");
out.println("</html>");

        }
	} catch (SQLException e) {
	    out.println("executeQuery " + e.getMessage());
        return;
	  }
	
	try {
     stmt.close();
     conn.close();	
	} catch (SQLException e) {
	    out.println("executeQuery " + e.getMessage());
        return;
	  }
	
	out.close();
  }
    
    
  public String getServletInfo() {
    return "This Servlet processes Banner";
  }
    
    
}

