import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import oracle.html.*;

public class jwebTest extends HttpServlet {
  public void init(ServletConfig config) throws ServletException {
   super.init(config);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse res) 
           throws ServletException, IOException {
    doPost(req,res);
  }
  public void doPost(HttpServletRequest req, HttpServletResponse res) 
           throws ServletException, IOException {

      String firstName = req.getParameter("FirstName");
   String lastName = req.getParameter("LastName");
    int numIter = Integer.parseInt(req.getParameter("numIterations"));

   PrintWriter out = res.getWriter();
   //OutputStream out = res.getOutputStream();
   res.setContentType("text/html");

   HtmlHead hd = new HtmlHead("Simple Example");
   HtmlBody bd = new HtmlBody();
   HtmlPage hp = new HtmlPage(hd, bd);
   //hp.printHeader();

   bd.addItem(new SimpleItem("This is a Heading (level2) ").setHeading(2));

   bd.addItem(new SimpleItem("Good Day! "+firstName+" "+lastName).setBold())
     .addItem(SimpleItem.LineBreak);

   bd.addItem(SimpleItem.HorizontalRule);

   for (int i = 0; i < numIter; i++) {
     bd.addItem(new SimpleItem("This is Line ").setEmphasis())
       .addItem(new SimpleItem(i))
       .addItem(SimpleItem.LineBreak);
   }

   bd.addItem(SimpleItem.HorizontalRule);

   Preformat pre = new Preformat();
   pre.addItem("void main () {\n")
      .addItem("  int i;\n\n")
      .addItem("  i = 5;\n")
      .addItem("  printf(\"i = %d\\n\",i);\n")
      .addItem("}\n");

   bd.addItem(pre); 
   bd.addItem(SimpleItem.HorizontalRule);

   out.println(hp);

   out.close();
  }

  public void destroy() {
  }
}   
