<?xml version="1.0"?>

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:param name="cat">COMPUTING</xsl:param>

<xsl:template match="/">
  <html>
  <body>
    <h2>Book Catalog</h2>
    <h3>Books in <xsl:value-of select="$cat"/> category</h3>
    <table border="1">
    <tr>
      <th align="left">Author</th>
      <th align="left">Title</th>
    </tr>
    <xsl:for-each select="books/book[@category=$cat]">
      <tr>
        <td><xsl:value-of select="author"/></td>
        <td><xsl:value-of select="title"/></td>
      </tr>
    </xsl:for-each>
    </table>
  </body>
  </html>
</xsl:template>

</xsl:stylesheet>
